︠35dbbb6f-0978-4028-9c72-64ea6f10ccb4i︠
%md
# PyFlux on SMC

Say hello to [PyFlux](http://www.pyflux.com/) on SageMathCloud!
︡8cf069a4-8b90-4559-b1be-4df2f392bde8︡{"done":true,"md":"# PyFlux on SMC\n\nSay hello to [PyFlux](http://www.pyflux.com/) on SageMathCloud!"}
︠e9f2bc1c-77c0-403f-87f6-a670041907a0s︠
import pyflux as pf
pf.__version__
︡b34b9b77-5618-4f83-b14e-11206bfaa534︡{"stderr":"Error in lines 1-1\n"}︡{"stderr":"Traceback (most recent call last):\n  File \"/usr/local/lib/python2.7/dist-packages/smc_sagews/sage_server.py\", line 976, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\n  File \"/projects/sage/sage-7.5/local/lib/python2.7/site-packages/pyflux/__init__.py\", line 17, in <module>\n    from .other import *\nImportError: No module named other\n"}︡{"done":true}︡
︠87d44f88-1aee-4a38-9341-1adf4fc4f740s︠
import numpy as np
import pandas as pd
import pyflux as pf
from datetime import datetime
import matplotlib.pyplot as plt

data = pd.read_csv('https://vincentarelbundock.github.io/Rdatasets/csv/datasets/sunspot.year.csv')
data.index = data['time'].values

_=plt.figure(figsize=(15,5))
_=plt.plot(data.index,data['sunspot.year'])
_=plt.ylabel('Sunspots')
_=plt.title('Yearly Sunspot Data')
plt.show()
︡f5a7bb07-c7b7-4eac-80e2-16c2e6474b96︡{"stderr":"Error in lines 3-3\nTraceback (most recent call last):\n  File \"/usr/local/lib/python2.7/dist-packages/smc_sagews/sage_server.py\", line 976, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\n  File \"/projects/sage/sage-7.5/local/lib/python2.7/site-packages/pyflux/__init__.py\", line 3, in <module>\n    from . import __check_build\nImportError: cannot import name __check_build\n"}︡{"done":true}︡
︠89365f2f-88b2-4bf5-af32-51b6863c489as︠
model = pf.ARIMA(data=data, ar=4, ma=4, target='sunspot.year', family=pf.Normal())
︡338f5e15-845a-4376-98df-6cc84728457c︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/usr/local/lib/python2.7/dist-packages/smc_sagews/sage_server.py\", line 976, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\nNameError: name 'pf' is not defined\n"}︡{"done":true}︡
︠6b4795ef-f6f4-4347-b112-021f2f02239as︠
x = model.fit("MLE")
x.summary()
︡73b69b36-5a81-4f73-9250-dd7564ad5466︡{"stdout":"Normal ARIMA(4,0,4)                                                                                       \n======================================================= ==================================================\nDependent Variable: sunspot.year                        Method: MLE                                       \nStart Date: 1704                                        Log Likelihood: -1191.3335                        \nEnd Date: 1988                                          AIC: 2402.6669                                    \nNumber of observations: 285                             BIC: 2439.1918                                    \n==========================================================================================================\nLatent Variable                          Estimate   Std Error  z        P>|z|    95% C.I.                 \n======================================== ========== ========== ======== ======== =========================\nConstant                                 10.9013    2.5712     4.2397   0.0      (5.8617 | 15.9409)       \nAR(1)                                    1.5132     0.0415     36.4212  0.0      (1.4318 | 1.5947)        \nAR(2)                                    -0.3377    0.2406     -1.4036  0.1604   (-0.8093 | 0.1339)       \nAR(3)                                    -0.8512    0.2357     -3.6111  0.0003   (-1.3133 | -0.3892)      \nAR(4)                                    0.452      0.0629     7.186    0.0      (0.3287 | 0.5753)        \nMA(1)                                    -0.3643    0.0385     -9.4559  0.0      (-0.4399 | -0.2888)      \nMA(2)                                    -0.4585    0.1362     -3.3669  0.0008   (-0.7254 | -0.1916)      \nMA(3)                                    0.2186     0.1121     1.9495   0.0512   (-0.0012 | 0.4383)       \nMA(4)                                    0.2996     0.0813     3.6831   0.0002   (0.1401 | 0.459)         \nNormal Scale                             15.8542                                                          \n==========================================================================================================\n"}︡{"done":true}︡
︠56431ea3-5bc5-4c2c-97ef-d1c00ed63b58i︠
%md
## Latent variables ...
︡fdf110b5-5e5e-4b7b-80e1-f99d3a55aa2f︡{"done":true,"md":"## Latent variables ..."}
︠8720bc2a-1d57-4100-9fde-ca01bd23c39c︠
model.plot_z(figsize=(15,5))
︡8b334b5a-5d94-4178-a0a1-7d22886f36c1︡{"file":{"filename":"972d9a81-3177-45fa-94a6-f2567b9506a8.svg","show":true,"text":null,"uuid":"d0f0d3c9-8f1d-415a-8b67-74e85cf637b5"},"once":false}︡{"done":true}︡
︠7d8d86ea-8abb-4ea1-97e5-2ee5cdc2431di︠
%md
## In-sample fit
︡12e4b049-997e-4034-bb40-93fcc6a73020︡{"done":true,"md":"## In-sample fit"}
︠874d0ba2-029e-46ca-a6eb-be810e2b0e59s︠
model.plot_fit(figsize=(15,10))
︡1883809d-49d3-4d1e-92e6-37c3d19e3127︡{"file":{"filename":"6b5433b2-935e-4e1c-8d46-f17354c3c89c.svg","show":true,"text":null,"uuid":"4b93bc12-0e82-4fa0-9f7b-9ea63a147a86"},"once":false}︡{"done":true}︡
︠d9358e1e-1b47-44a0-a2c6-906f6895da53i︠
%md
## Prediction
︡13a72128-7332-43b2-92ff-d55ab82b9dcb︡{"done":true,"md":"## Prediction"}
︠eee62901-4160-44a0-987e-e455b113f5b4s︠
model.plot_predict(h=20,past_values=20,figsize=(15,5))
︡5b872eda-dac8-4655-a51a-702d83baee67︡{"file":{"filename":"ab08cfb6-1195-4d87-9d5f-a52c16096177.svg","show":true,"text":null,"uuid":"d37794d5-b0d3-4af3-9ce3-2e49d6d79a69"},"once":false}︡{"done":true}︡
︠0f97275d-6591-4f91-bf91-4700921c7702︠









